// SDKTEST.h : CSDKTEST Դϴ.

#pragma once

// ڵ  ġ 2013 10 28 ,  1:44

class CSDKTESTAccessor
{
public:
	//TCHAR m_Book_Author[11];
	//TCHAR m_Book_Title[51];
	char m_Book_Author[11];
	char m_Book_Title[51];

	//         ش 
	// ʵ忡     ֽϴ.  
	// Ͽ ͺ̽ȯϴ NULL 
	// ϰų Ϸ  ȯ 
	//     ֽϴ. ̷ ʵ 뿡
	//  ڼ  Visual C++ 
	//  "  " "ʵ   " Ͻʽÿ.
	// : ͸ /ϱ  ̵ ʵ带 ʱȭؾ մϴ.

	DBSTATUS m_dwBook_AuthorStatus;
	DBSTATUS m_dwBook_TitleStatus;

	//        ش ʵ忡 
	//    ֽϴ.
	// :     ͸ /ϱ  
//       ̷ 	 ʵ带 ʱȭؾ մϴ.

	DBLENGTH m_dwBook_AuthorLength;
	DBLENGTH m_dwBook_TitleLength;


	void GetRowsetProperties(CDBPropSet* pPropSet)
	{
		pPropSet->AddProperty(DBPROP_CANFETCHBACKWARDS, true, DBPROPOPTIONS_OPTIONAL);
		pPropSet->AddProperty(DBPROP_CANSCROLLBACKWARDS, true, DBPROPOPTIONS_OPTIONAL);
		pPropSet->AddProperty(DBPROP_IRowsetChange, true, DBPROPOPTIONS_OPTIONAL);
		pPropSet->AddProperty(DBPROP_UPDATABILITY, DBPROPVAL_UP_INSERT);
	}

	HRESULT OpenDataSource()
	{
		CDataSource _db;
		HRESULT hr;
//#error  :  ڿ ȣ ԵǾ   ֽϴ.
// Ʒ  ڿ Ϲ ؽƮ ȣ /Ǵ 
// ٸ ߿  ԵǾ   ֽϴ.
//    ִ  ڿ  Ŀ #error() Ͻʽÿ.
// ٸ  ȣ ϰų ٸ   Ͻʽÿ.
//		hr = _db.OpenFromInitializationString(L"Provider=SQLOLEDB.1;Persist Security Info=False;User ID=sa;Initial Catalog=OLEDB;Data Source=SHINT-NOTEBOOK\\SQLEXPRESS;Use Procedure for Prepare=1;Auto Translate=True;Packet Size=4096;Workstation ID=SHINT-NOTEBOOK;Use Encryption for Data=False;Tag with column collation when possible=False");
	 	hr = _db.OpenFromInitializationString(OLESTR("PROVIDER=SQLOLEDB;SERVER=SHINT-NOTEBOOK\\SQLEXPRESS;UID=sa;PWD=1;DATABASE=OLEDB")); 
		if (FAILED(hr))
		{
#ifdef _DEBUG
			AtlTraceErrorRecords(hr);
#endif
			return hr;
		}
		return m_session.Open(_db);
	}

	void CloseDataSource()
	{
		m_session.Close();
	}

	operator const CSession&()
	{
		return m_session;
	}

	CSession m_session;

	//DEFINE_COMMAND_EX(CSDKTESTAccessor, L" \
	//SELECT \
	//	Book_Author, \
	//	Book_Title \
	//	FROM dbo.SDKTEST")
	DEFINE_COMMAND_EX(CSDKTESTAccessor, L"INSERT INTO dbo.SDKTEST(Book_Author,Book_Title) VALUES(?,?)")


	// Ϻ ڿ õ   ذϱ  Ʒ ڵ忡 
	// ڰ ϴ Ͱ ٸ   ε  ֽϴ.
	BEGIN_PARAM_MAP(CSDKTESTAccessor)
		COLUMN_ENTRY(1, m_Book_Author)
		COLUMN_ENTRY(2, m_Book_Title)
	END_PARAM_MAP()

	// ڵ ϸ 
	//BEGIN_COLUMN_MAP(CSDKTESTAccessor)
	//	COLUMN_ENTRY_LENGTH_STATUS(1, m_Book_Author, m_dwBook_AuthorLength, m_dwBook_AuthorStatus)
	//	COLUMN_ENTRY_LENGTH_STATUS(2, m_Book_Title, m_dwBook_TitleLength, m_dwBook_TitleStatus)
	//END_COLUMN_MAP()
};


//ø ϴ 
template<class CSDKTESTAccessor>

class CSDKTEST : public CCommand<CAccessor<CSDKTESTAccessor> >
{
public:
	HRESULT OpenAll()
	{
		HRESULT hr;
		hr = OpenDataSource();
		if (FAILED(hr))
			return hr;
		__if_exists(GetRowsetProperties)
		{
			CDBPropSet propset(DBPROPSET_ROWSET);
			__if_exists(HasBookmark)
			{
				if( HasBookmark() )
					propset.AddProperty(DBPROP_IRowsetLocate, true);
			}
			GetRowsetProperties(&propset);
			return OpenRowset(&propset);
		}
		__if_not_exists(GetRowsetProperties)
		{
			__if_exists(HasBookmark)
			{
				if( HasBookmark() )
				{
					CDBPropSet propset(DBPROPSET_ROWSET);
					propset.AddProperty(DBPROP_IRowsetLocate, true);
					return OpenRowset(&propset);
				}
			}
		}
		return OpenRowset();
	}

	HRESULT OpenRowset(DBPROPSET *pPropSet = NULL)
	{
		HRESULT hr = Open(m_session, NULL, pPropSet);
#ifdef _DEBUG
		if(FAILED(hr))
			AtlTraceErrorRecords(hr);
#endif
		return hr;
	}

	void CloseAll()
	{
		Close();
		ReleaseCommand();
		CloseDataSource();
	}
};


